
{------------------------------------------------------------------------------}
{ SkComboHint v1.00                                                            }
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{ For any questions or comments I can be reached at:                           }
{  Web site :  http://www.pana.com/~robert                                     }
{  EMail    :  robert@pana.com                                                 }
{------------------------------------------------------------------------------}
{ Date last modified:  July 11, 1999                                           }
{------------------------------------------------------------------------------}
{ Usage : Install. Then just drop the component on your form.                  }
{         For the Hints to work, this ComboBox MUST BE OwnerDraw.              }
{         No coding is needed other than the usual 'Add.Item'                  }
{         Other than the Hints coming up, it works the same as any other       }
{         TComboBox.                                                           }
{         You also have the option of having the hint stay if the item that    }
{         had the last hint goes out of view (The ShowHintWhenHidden property) }
{------------------------------------------------------------------------------}
{ This component is freeware. Do with it what ever you want. but               }
{ I will not be held liable for any damage it does (you have the source).      }
{------------------------------------------------------------------------------}


unit SkComboHint;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, DsgnIntf, stdctrls;

type
  TSkComboHintAbout = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TSkComboHint = class(TComboBox)
  private
    FAbout: TSkComboHintAbout;
    FHintWin : THintWindow;
    FHintStr : String;
    FHintWidth : Integer;
    FCmbWidth : Integer;
    FTopIndex : Integer;
    FBottomIndex : Integer;
    CurHintIndex : Integer;
    FHintWhenHidden : Boolean;
    function GetTopIndex: Integer;
    function GetBottomIndex : Integer;
  public
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
    procedure Loaded; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property TopIndex: Integer read GetTopIndex write FTopIndex;
    property BottomIndex : Integer read FBottomIndex write FBottomIndex;
    property CurrentIndex : Integer read CurHintIndex write CurHintIndex;
  published
    property About: TSkComboHintAbout read FAbout write FAbout;
    property ShowHintWhenHidden : Boolean read FHintWhenHidden write FHintWhenHidden default false;
  end;

procedure Register;

implementation

procedure TSkComboHintAbout.Edit;
begin
  Application.MessageBox('TSkComboHint component v1.00 for Delphi. (C) 1999 Robert Jones. This component is freeware.',
                         'About TSkComboHint Component', MB_OK + MB_ICONINFORMATION);
end;

function TSkComboHintAbout.GetAttributes: TPropertyAttributes;
begin
  Result:= [paMultiSelect, paDialog, paReadOnly];
end;

function TSkComboHintAbout.GetValue: string;
begin
  Result:= '(about)';
end;

constructor TSkComboHint.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FHintStr := '';
  FHintWidth := 0;
  Style := csOwnerDrawFixed;
end;

procedure TSkComboHint.Loaded;
begin
 FCmbWidth := Width - GetSystemMetrics(SM_CXHTHUMB);
end;

function TSkComboHint.GetTopIndex: Integer;
begin
  Result := SendMessage(Handle, CB_GETTOPINDEX, 0, 0);
end;

function TSkComboHint.GetBottomIndex : Integer;
begin
 Result := GetTopIndex + DropDownCount;
end;

procedure TSkComboHint.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
 Var 
  CurHint : String;
  CmbPoint : TPoint;
  CmbRect : TRect;
  CmbHeight : Integer;
  CmbDropHeight : Integer;
begin
 Inherited;
 FHintStr := Items.Strings[Index];
 Canvas.FillRect(Rect);
 Canvas.TextOut(Rect.Left, Rect.Top, FHintStr); 
  If (odSelected In State) Then
   begin
    If CurHint <> FHintStr Then
     begin
       CurHint := FHintStr;
      If Assigned(FHintWin) Then
        FHintWin.ReleaseHandle;
         If DroppedDown Then
          begin
          FTopIndex := GetTopIndex;
          FBottomIndex := GetBottomIndex;
          CurHintIndex := Items.IndexOf(CurHint);
           If (CurHintIndex < FBottomIndex) And (CurHintIndex >= FTopIndex)
              Or ShowHintWhenHidden Then
            begin
              FHintWidth := Canvas.TextWidth(FHintStr);
               If FHintWidth > FCmbWidth Then
                begin
                 FHintWin := THintWindow.Create(Self);
                 FHintWin.Color := clInfoBk; 
                 CmbHeight := Canvas.TextHeight(FHintStr);  
                 CmbDropHeight := CmbHeight * DropDownCount;
                 cmbPoint := ClientOrigin;
                 CmbRect.Left := cmbPoint.x + (FCmbWidth div 2);
                  If cmbPoint.y + CmbHeight + Rect.Top < cmbPoint.y Then
                   CmbRect.Top := cmbPoint.y + 45
                    else
                  If cmbPoint.y + CmbHeight + Rect.Top + 5 > cmbPoint.y + Height + CmbDropHeight Then
                     CmbRect.Top := cmbPoint.y + Height + CmbDropHeight + 45
                    else 
                     CmbRect.Top := cmbPoint.y + CmbHeight + Rect.Top + 45;
                     CmbRect.Bottom := CmbRect.Top + CmbHeight + 2;
                 CmbRect.Right := CmbRect.Left + FHintWidth + 10;
                  FHintWin.ActivateHint(CmbRect, FHintStr);
                end;
            end;
          end;
        end;
      end;
end;

destructor TSkComboHint.Destroy;
begin
 If Assigned(FHintWin) Then
    FHintWin.ReleaseHandle;
  inherited Destroy;
end;


procedure Register;
begin
  RegisterComponents('SK', [TSkComboHint]);
  RegisterPropertyEditor(TypeInfo(TSkComboHintAbout), TSkComboHint, 'ABOUT', TSkComboHintAbout);
end;

end.
